/**
 * generated by Xtext 2.19.0
 */
package fr.istic.mML.impl;

import fr.istic.mML.Evaluation;
import fr.istic.mML.MMLPackage;
import fr.istic.mML.StrategyEvaluation;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Evaluation</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link fr.istic.mML.impl.EvaluationImpl#getStrategyEvaluation <em>Strategy Evaluation</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EvaluationImpl extends MinimalEObjectImpl.Container implements Evaluation
{
  /**
   * The cached value of the '{@link #getStrategyEvaluation() <em>Strategy Evaluation</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getStrategyEvaluation()
   * @generated
   * @ordered
   */
  protected StrategyEvaluation strategyEvaluation;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected EvaluationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return MMLPackage.Literals.EVALUATION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public StrategyEvaluation getStrategyEvaluation()
  {
    return strategyEvaluation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetStrategyEvaluation(StrategyEvaluation newStrategyEvaluation, NotificationChain msgs)
  {
    StrategyEvaluation oldStrategyEvaluation = strategyEvaluation;
    strategyEvaluation = newStrategyEvaluation;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MMLPackage.EVALUATION__STRATEGY_EVALUATION, oldStrategyEvaluation, newStrategyEvaluation);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setStrategyEvaluation(StrategyEvaluation newStrategyEvaluation)
  {
    if (newStrategyEvaluation != strategyEvaluation)
    {
      NotificationChain msgs = null;
      if (strategyEvaluation != null)
        msgs = ((InternalEObject)strategyEvaluation).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - MMLPackage.EVALUATION__STRATEGY_EVALUATION, null, msgs);
      if (newStrategyEvaluation != null)
        msgs = ((InternalEObject)newStrategyEvaluation).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - MMLPackage.EVALUATION__STRATEGY_EVALUATION, null, msgs);
      msgs = basicSetStrategyEvaluation(newStrategyEvaluation, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MMLPackage.EVALUATION__STRATEGY_EVALUATION, newStrategyEvaluation, newStrategyEvaluation));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case MMLPackage.EVALUATION__STRATEGY_EVALUATION:
        return basicSetStrategyEvaluation(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case MMLPackage.EVALUATION__STRATEGY_EVALUATION:
        return getStrategyEvaluation();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case MMLPackage.EVALUATION__STRATEGY_EVALUATION:
        setStrategyEvaluation((StrategyEvaluation)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case MMLPackage.EVALUATION__STRATEGY_EVALUATION:
        setStrategyEvaluation((StrategyEvaluation)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case MMLPackage.EVALUATION__STRATEGY_EVALUATION:
        return strategyEvaluation != null;
    }
    return super.eIsSet(featureID);
  }

} //EvaluationImpl
